﻿'
'EWFMonitorNET
'SJJ Embedded Micro Solutions
'Copyright (c) 2004-2010 SJJ Micro Solutions    All Rights Reserved
'
'
'EWFMonitorNET Form
'
' Date: 8/1/10 - Comments generated
'Test application for EWF .NET solution. The application performs the EWF functions
'on a protected drive C. You can change the drive to any drive you want.
'
'Source code is provided as is without any warranty

Imports EWFNET.SJJEMS.EWFAPI


Public Class frmEWFMonitorNET

    Private Sub frmEWFMonitorNET_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        EWFUpdate()

    End Sub




    '--------------------------------------------------------------------------
    'cmdEWFUpdate
    'This subroutine makes three seperate calls to get the status of the EWF
    'drive - Type, State, Current Boot Command.
    'The routine is called by each of the button routines above as well as
    'the start of the application.

    Sub EWFUpdate()

        Dim DriveH As String = "C:"
        Dim sType As String
        Dim sState As String
        Dim sCommand As String

        sType = EWFStatus_Type(DriveH)
        sState = EWFStatus_State(DriveH)
        sCommand = EWFStatus_Command(DriveH)

        txtType.Text = sType
        txtStatus.Text = sState
        txtCommand.Text = sCommand
        Update()

    End Sub





    '--------------------------------------------------------------------------
    'cmdEnable_Click
    'Performs an EWF Enable, The Result returns a Long number that gets
    'converted into hex.
    '

    Private Sub cmdEnable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnable.Click

        Dim DriveH As String = "C:"
        Dim lResult As Long
        Dim sResult As String
        Dim FResults As String


        lResult = EwfEnable(DriveH)
        FResults = Hex(lResult)


        'Alternative to this select case is to change the EWFNET.DLL
        'to return a String value to put all the work in the DLL
        'instead of the .NET application.

        Select Case FResults.Substring(8, 8)
            Case "00000000"
                sResult = "Success - EWF Enable"
            Case "00000001"
                sResult = "Drive is Not Protected"
            Case "00000002"
                sResult = "No Such Drive (bad handle)"
            Case "00000057"
                sResult = "Requested State is Already Active"
            Case Else
                sResult = "Failure"
        End Select
        txtResult.Text = sResult
        Update()
        EWFUpdate()

    End Sub

    '--------------------------------------------------------------------------
    'cmdDisable_Click
    'Performs an EWF Disable, The Result returns a Long number that gets
    'converted into hex.
    '
    Private Sub cmdDisable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDisable.Click

        Dim DriveH As String = "C:"
        Dim lResult As Long
        Dim sResult As String
        Dim FResults As String

        lResult = EwfDisable(DriveH, False)
        FResults = Hex(lResult)

        'Alternative to this select case is to change the EWFNET.DLL
        'to return a String value to put all the work in the DLL
        'instead of the .NET application.

        Select Case FResults.Substring(8, 8)
            Case "00000000"
                sResult = "Success - EWF Disabled"
            Case "00000001"
                sResult = "Drive is Not Protected"
            Case "00000002"
                sResult = "No Such Drive (bad handle)"
            Case "00000057"
                sResult = "Requested State is Already Active"
            Case Else
                sResult = "Failure"
        End Select
        txtResult.Text = sResult
        Update()
        EWFUpdate()


    End Sub


    '--------------------------------------------------------------------------
    'cmdCommit_Click
    'Performs an EWF Commit, The Result returns a Long number that gets
    'converted into hex.
    '
    Private Sub cmdCommit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCommit.Click
        Dim DriveH As String = "C:"
        Dim lResult As Long
        Dim sResult As String
        Dim FResults As String

        lResult = EwfCommit(DriveH)
        FResults = Hex(lResult)

        'Alternative to this select case is to change the EWFNET.DLL
        'to return a String value to put all the work in the DLL
        'instead of the .NET application.

        Select Case FResults.Substring(8, 8)
            Case "00000000"
                sResult = "Success - Commit"
            Case "00000001"
                sResult = "Drive is Not Protected"
            Case "00000002"
                sResult = "No Such Drive (bad handle)"
            Case "00000057"
                sResult = "Requested State is Already Active"
            Case Else
                sResult = "Failure"
        End Select
        txtResult.Text = sResult
        Update()
        EWFUpdate()
    End Sub

    '--------------------------------------------------------------------------
    'cmdCDL_Click
    'Performs an EWF Commit And Disable Live, The Result returns a Long number that gets
    'converted into hex.
    '

    Private Sub cmdCDL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCDL.Click
        Dim DriveH As String = "C:"
        Dim lResult As Long
        Dim sResult As String
        Dim FResults As String

        lResult = EwfCommitandDisableLive(DriveH)
        FResults = Hex(lResult)

        'Alternative to this select case is to change the EWFNET.DLL
        'to return a String value to put all the work in the DLL
        'instead of the .NET application.

        Select Case FResults.Substring(8, 8)
            Case "00000000"
                sResult = "Success - EWF Disabled / Commit"
            Case "00000001"
                sResult = "Drive is Not Protected"
            Case "00000002"
                sResult = "No Such Drive (bad handle)"
            Case "00000057"
                sResult = "Requested State is Already Active"
            Case Else
                sResult = "Failure"
        End Select
        txtResult.Text = sResult
        Update()
        EWFUpdate()



    End Sub
    '--------------------------------------------------------------------------
    'cmdClear_Click
    'Performs an EWF Clear, The Result returns a Long number that gets
    'converted into hex.
    '
    Private Sub cmdClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClear.Click
        Dim DriveH As String = "C:"
        Dim lResult As Long
        Dim sResult As String
        Dim FResults As String

        lResult = EwfClearCommand(DriveH)
        FResults = Hex(lResult)

        'Alternative to this select case is to change the EWFNET.DLL
        'to return a String value to put all the work in the DLL
        'instead of the .NET application.

        Select Case FResults.Substring(8, 8)
            Case "00000000"
                sResult = "Success - Clear"
            Case "00000001"
                sResult = "Drive is Not Protected"
            Case "00000002"
                sResult = "No Such Drive (bad handle)"
            Case Else
                sResult = "Failure"
        End Select
        txtResult.Text = sResult
        Update()
        EWFUpdate()
    End Sub
End Class
