// KeyboardHookTrap.cpp : Defines the initialization routines for the DLL.
//

////////////////////////////////////////////////////////////////
// MSDN Magazine -- September 2002
// Originally written by Paul DiLascia.
//
//
// This file implements the low-level keyboard hook that traps the task keys.
//
// Modified by SJJ Embedded Micro Solutions
// Modified for Exercise 502 Demo
// Copyright (c) 2004 SJJ Embedded Micro Solutions, LLC
// All Rights Reserved
// Code is provided AS IS without any warranty


#define _WIN32_WINNT 0x0500 // for KBDLLHOOKSTRUCT
#include "stdafx.h"
#include "KeyboardHookTrap.h"
#include <afxwin.h>         // MFC core and standard components

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//		any functions exported from this DLL which call into
//		MFC must have the AFX_MANAGE_STATE macro added at the
//		very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CKeyboardHookTrapApp

BEGIN_MESSAGE_MAP(CKeyboardHookTrapApp, CWinApp)
END_MESSAGE_MAP()


// CKeyboardHookTrapApp construction

CKeyboardHookTrapApp::CKeyboardHookTrapApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CKeyboardHookTrapApp object

CKeyboardHookTrapApp theApp;


// CKeyboardHookTrapApp initialization

BOOL CKeyboardHookTrapApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}
//////////////////
// App (DLL) object
//
class CKeyboardHookTrapDll : public CWinApp {
public:
	CKeyboardHookTrapDll()  { }
	~CKeyboardHookTrapDll() { }
} MyDll;

////////////////
// The section is SHARED among all instances of this DLL.
// A low-level keyboard hook is always a system-wide hook.
// 
#pragma data_seg (".mydata")
HHOOK g_hHookKbdLL = NULL; // hook handle
BOOL  g_bBeep = FALSE;		// beep on illegal key
#pragma data_seg ()
#pragma comment(linker, "/SECTION:.mydata,RWS") // tell linker: make it shared

/////////////////
// Low-level keyboard hook:
// Trap task-switching keys by returning without passing along.
//
LRESULT CALLBACK MyKeyboardHookTrapDLL(int nCode, WPARAM wp, LPARAM lp)
{
	KBDLLHOOKSTRUCT *pkh = (KBDLLHOOKSTRUCT *) lp;

	if (nCode==HC_ACTION) {
		BOOL bCtrlKeyDown =	GetAsyncKeyState(VK_CONTROL)>>((sizeof(SHORT) * 8) - 1);
		
		//Add or subtract Virtual code combinations to trap
		if ((pkh->vkCode==VK_ESCAPE && bCtrlKeyDown) ||					// Ctrl+Esc
			 (pkh->vkCode==VK_TAB && pkh->flags & LLKHF_ALTDOWN) ||		// Alt+TAB
			 (pkh->vkCode==VK_ESCAPE && pkh->flags & LLKHF_ALTDOWN)||	// Alt+Esc
			 (pkh->vkCode==VK_LWIN || pkh->vkCode==VK_RWIN)||			// Start Menu
			 (pkh->vkCode==VK_F4 && pkh->flags & LLKHF_ALTDOWN)||		// ALT-F4
			 (pkh->vkCode==VK_F1)){									 // F1 Typcial Help	
			if (g_bBeep && (wp==WM_SYSKEYDOWN||wp==WM_KEYDOWN))
				MessageBeep(0); // only beep on downstroke if requested
			return 1; // gobble it: go directly to jail, do not pass go
		}
	}
	return CallNextHookEx(g_hHookKbdLL, nCode, wp, lp);
}

//////////////////
// Are task keys disabled--ie, is hook installed?
// Note: This assumes there's no other hook that does the same thing!
//
BOOL AreTaskKeysDisabled()
{
	return g_hHookKbdLL != NULL;
}

//////////////////
// Disable task keys: install low-level kbd hook.
// Return whether currently disabled or not.
//
BOOL DisableTaskKeys(BOOL bDisable, BOOL bBeep)
{
	if (bDisable) {
		if (!g_hHookKbdLL) {
			g_hHookKbdLL = SetWindowsHookEx(WH_KEYBOARD_LL,
				MyKeyboardHookTrapDLL, MyDll.m_hInstance, 0);
		}

	} else if (g_hHookKbdLL != NULL) {
		UnhookWindowsHookEx(g_hHookKbdLL);
		g_hHookKbdLL = NULL;
	}
	g_bBeep = bBeep;

	return AreTaskKeysDisabled();
}

