﻿//SJJ_GPS
//SJJ Embedded Micro Solutions, LLC.
//www.sjjmicro.com 
//Copyright (c) 2010 SJJ Embedded Micro Solutions, LLC    All Rights Reserved.


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Windows7.Location;

namespace SJJ_GPS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            LatLongLocationProvider LatLongLocP = new LatLongLocationProvider(100);
            
            LatLongLocP.LocationChanged += new LocationChangedEventHandler(LatLongLocP_LocationChanged);
            LatLongLocP.StatusChanged += new LocationProviderStatusChangedEventHandler(LatLongLocP_StatusChanged);

            if (LatLongLocP.ReportStatus == ReportStatus.Running)
            {
                UpdateLocationReport((LatLongLocationReport)LatLongLocP.GetReport());
            }

            CivicAddressLocationProvider CivAddrLocP = new CivicAddressLocationProvider(1000);

            CivAddrLocP.LocationChanged += new LocationChangedEventHandler(CivAddrLocP_LocationChanged);
            CivAddrLocP.StatusChanged += new LocationProviderStatusChangedEventHandler(CivAddrLocP_StatusChanged);

            if (CivAddrLocP.ReportStatus == ReportStatus.Running)
            {
                
                UpdateLocationReport((CivicAddressLocationReport)CivAddrLocP.GetReport());
            }
                                           


        }

        //CivicAddress Events
        void CivAddrLocP_StatusChanged(LocationProvider locationProvider, ReportStatus status)
        {
            switch (status)
            {
                case ReportStatus.AccessDenied:
                    txtCivicStatus.Text = "Acces Denied";
                    break;
                case ReportStatus.Error:
                    txtCivicStatus.Text = "Report Error";
                    break;
                case ReportStatus.Initializing:
                    txtCivicStatus.Text = "Report is initializing";
                    break;
                case ReportStatus.NotSupported:
                    txtCivicStatus.Text = "No devices detected";
                    break;
                case ReportStatus.Running:
                    txtCivicStatus.Text = "Running";
                    break;
                default:
                    break;
            }
        }

        void CivAddrLocP_LocationChanged(LocationProvider locationProvider, LocationReport newLocation)
        {
            if (locationProvider.ReportStatus == ReportStatus.Running)
            {

                CivicAddressLocationReport CivAddrReport = newLocation as CivicAddressLocationReport;
                if(CivAddrReport != null)
                {
                    UpdateLocationReport(CivAddrReport);

                }

            }
        }



        //Location Events
        void LatLongLocP_StatusChanged(LocationProvider locationProvider, ReportStatus status)
        {
            switch (status)
            {
                case ReportStatus.AccessDenied:
                    txtLoclatLongStatus.Text = "Acces Denied";
                    break;
                case ReportStatus.Error:
                    txtLoclatLongStatus.Text = "Report Error";
                    break;
                case ReportStatus.Initializing:
                    txtLoclatLongStatus.Text = "Report is initializing";
                    break;
                case ReportStatus.NotSupported:
                    txtLoclatLongStatus.Text = "No devices detected";
                    break;
                case ReportStatus.Running:
                    txtLoclatLongStatus.Text = "Running";
                    break;
                default:
                    break;
            }

        }
        
        void LatLongLocP_LocationChanged(LocationProvider locationProvider, LocationReport newLocation)
        {
            if (locationProvider.ReportStatus == ReportStatus.Running)
            {
                LatLongLocationReport LatLongReport = newLocation as LatLongLocationReport;
                if (LatLongReport != null)
                {
                    UpdateLocationReport(LatLongReport);

                }
            }
        }

        //Update Dialog Box Interface
        public void UpdateLocationReport(LocationReport locReport)
        {

            LatLongLocationReport LatLongLocReport = locReport as LatLongLocationReport;
            if (LatLongLocReport != null)
            {
                txtLocLatSensorID.Text = LatLongLocReport.SensorID.ToString();
                txtLat.Text = LatLongLocReport.Latitude.ToString();
                txtLong.Text = LatLongLocReport.Longitude.ToString();
                txtErrorRadius.Text = LatLongLocReport.ErrorRadius.ToString();
                txtLocLatTime.Text = LatLongLocReport.Timestamp.ToString();
                
                try
                {
                    txtAlt.Text = LatLongLocReport.Altitude.ToString();
                }
                catch
                {
                    txtAlt.Text = "Unsupported";
                }
                try
                {
                    txtAltError.Text = LatLongLocReport.AltitudeError.ToString();
                }
                catch
                {
                    txtAltError.Text = "Unsupported";
                }


            }

            CivicAddressLocationReport CivAddrReport = locReport as CivicAddressLocationReport;

            if (CivAddrReport != null)
            {

                txtCivicSensorID.Text = CivAddrReport.SensorID.ToString();
                txtCivicTime.Text = CivAddrReport.Timestamp.ToString();
                txtAddress1.Text = CivAddrReport.AddressLine1.ToString();
                txtAddress2.Text = CivAddrReport.AddressLine2.ToString();
                txtCity.Text = CivAddrReport.City.ToString();
                txtState.Text = CivAddrReport.StateOrProvince.ToString();
                txtZip.Text = CivAddrReport.PostalCode.ToString();
                
                
            }

        }


    }
}
